#!/usr/bin/perl
##############################################################################
# Cliff's Thumbnail Gallery Post Script Version 1.04                         # 
# Copyright 1998 Shaven Ferret Productions                                   #
# Created: 5/25/99             Last Modified: 09/28/99                       #
# Available at http://www.shavenferret.com/scripts                           #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 Shaven Ferret Productions All Rights Reserved.              #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header, or the parts of this script that generate the return   #
# link\form.  If you really need to remove these, go to                      #
# http://www.shavenferret.com/scripts/register.shtml .  By using this script #
# you agree to indemnify me from any liability that might arise from its use.#
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

require "tgpsetup.cgi";
require "tgp-lib.cgi";
&start;

if ($FORM{'action'} eq "rate") { &ratepost; }
elsif ($FORM{'action'} eq "post") { &post; }
elsif ($FORM{'action'} eq "preview") { &preview; }
elsif ($FORM{'action'} eq "preview2") { &preview2; }
elsif ($FORM{'action'} eq "search") { &search; }
elsif ($FORM{'action'} eq "random") { &random; }
else { &submit; }

sub ratepost {
        open(FILE,"$datadir/r$FORM{'postnum'}.txt");
        my $junk = <FILE>;
        close(FILE);
        ($total,$votes,$last) = split(/\|/,$junk);        
        if ($last eq $ENV{'REMOTE_ADDR'}) { &error("You just rated this post."); }
        if ($FORM{'rating'} > 10 || $FORM{'rating'} < 1) { &error("You're trying to cheat, aren't you?"); }
        $total += $FORM{'rating'};
        $votes++;
        open(FILE,">$datadir/r$FORM{'postnum'}.txt");
        print FILE "$total|$votes|$ENV{'REMOTE_ADDR'}";
        close(FILE);
        print "<html><head><title>$title</title></head>\n";
        &body("FILE");
        unless ($norate) { print "<table width=\"100%\" cols=\"3\" height=\"100%\">\n"; }
        else { print "<table width=\"100%\" cols=\"2\" height=\"100%\">\n"; }
        print "<tr><td valign=\"top\"><font size=\"+1\">$font<center>Back to<br>\n";
        print "<a href=\"$posturl/index$ex\" target=\"_top\">$tgptitle</a>$cfont\n";
        print "</font></center></td>\n";
        print "<center>Your rating of $FORM{'rating'} has been recorded.\n";
        print "$cfont</center></body></html>\n";
        print "<td valign=\"top\"><center>$font<font size=\"+1\">\n";
        print "<a href=\"$FORM{'post_url'}\" target=\"_top\">Get Rid of this frame!</a>$cfont</center></font>\n";
        print "</center></td></tr></table></body></html>\n";
        if ($eachrate) { &update; }
        exit;
}

sub submit {
        &top("Add your gallery.","STDOUT");
        print "$posthead<h2>Step 1:</h2>\n";
        if ($link) {
                print "We require a return link.  Please copy and paste the\n";
                print "following HTML into your web page:<center><br><form><textarea name=\"x\" cols=\"60\" rows=\"5\">\n";
                print "$link</textarea></form></center><br>In case you're wondering, that\n";
                print "HTML will look like this:<p>$link<p><form method=\"POST\" action=\"$scripturl\">\n";
                unless ($samepage) {
                        print "<table cols=\"2\">\n";
                        &textrow("<a href=\"#1\">Enter the URL of the page with my link here</a>:","link_url","21","http://",-1);
                        $html .= "</table>\n";
                }
                else { $html .= "This link must be added to the gallery page."; }
                if ($link =~ /$counturl\?/) { $html .= "Please note that I do list sites by the ammount a return traffic I receive from them, so you will receive more hits if you give me a good link.\n"; }
                $html .= "<h2>Step 2:</h2>\n";
        }
        else { $html .= "<form method=\"POST\" action=\"$scripturl\">\n"; }
        $html .= "Please fill out the following information about the gallery you\n";
        $html .= "wish to post.<p>\n";
        $html .= "<center><table width=\"550\" border=\"5\"><tr><td>\n";
        if ($rules) { $html .= "<center><b>Rules: $rules</b></center>\n"; }
        $html .= "<table cols=\"2\">\n";        
        if ($samepage) { &textrow("<a href=\"#2\">URL of Gallery and my link\n</a>:","post_url","21","http://",-1); }
        else { &textrow("<a href=\"#2\">URL of Gallery\n</a>:","post_url","21","http://",-1); }
        if ($#post_types > 0) {
                @post_types = sort(@post_types);
                $html .= "<tr><td align=\"right\">$font"."<a href=\"#3\">Type of gallery</a>:$cfont</td><td><select name=\"post_type\">\n";
                foreach $type(@post_types) { $html .= "<option>$type\n"; }
                $html .= "</select></td></tr>\n";
        }       
        &textrow("<a href=\"#4\">Describe the gallery</a>:","post_desc","21","",-1);
        $html .= "<tr><td align=\"right\">$font"."How many images are in this gallery?$cfont</td><td>$font<select name=\"numimages\">\n";
        for ($i = 2; $i <= 100; $i++) {
                unless ($i == 10) { $html .= "<option>$i"; }
                else { $html .= "<option selected>10"; }
        }
        $html .= "</select>$cfont</td></tr>\n";        
        &textrow("<a href=\"#7\">Your E-mail address</a>:","email","21","",-1);
        $html .= "</table></td></tr></table><hr width=\"400\"></center><h2>Step ";
        if ($link) { $html .= "3:</h2>\n"; }
        else { $html .= "2:</h2>\n"; }
        unless ($showhints) {
                $html =~ s/<a href="#\d+">//ig;
                $html =~ s/<\/a>//ig;
        }
        print "$html";
        print "<input type=\"hidden\" name=\"action\" value=\"preview\">\n";
        print "Please make sure all of the information is correct and click\n";
        print "<input type=\"submit\" value=\" This Button \"></form><center>\n";
        print "<hr width=\"70%\">Thumbnail Gallery Post script by <a href=\"http";
        print "://www.shavenferret.com/cliff/\" target=\"new\">Cliff(tm)</a>, <a ";
        print "href=\"http://www.shavenferret.com\" target=\"new\">Shaven ";
        print "Ferret Productions</a>, and can be found at <a href=\"http:";
        print "//www.shavenferret.com/scripts\" target=\"new\">http://www.";
        print "shavenferret.com/scripts</a>.<hr width=\"70%\"></center>\n";
        if ($showhints) {
                print "<h1>Stuff you should know before posting</h1>\n";
                if ($link) {
                        print "<a name=\"1\"><h2>About your return link</h2></a><ul>\n";
                        print "<li>This script lets me lock out and blacklist certain sites.\n";
                        print "If you take down my link after a few days, put my link on a page\n";
                        print "with no links to it, or do some other sleazy thing then there's a good\n";
                        print "chance that you will be locked out from this, and several other\n";
                        print "pic-post sites.\n";
                        if ($samepage) { print "<li>My link must be added to your gallery page.\n"; }
                        if($link =~ /$counturl\?/) {
                                print "<li>I list sites by the ammount of return traffic they send\n";
                                print "me, as well as chronologically, by rating, and by category.\n";
                                print "If you give me a good link, more people will see your post,\n";
                                print "and you will receive more traffic.\n";
                        }
                        print "</ul>\n";
                }
                print "<a name=\"2\"><h2>About your gallery</h2></a><ul>\n";
                print "<li>This script allows users to rate galleries on a scale of\n";
                print "1 to 10, and view them accordingly.  If you post a good gallery,\n";
                print "more people will see it.</li>\n";
                print "<li>This script allows me to report child pornography with the\n";
                print "click of a button.  If you try to post child pornography, you can\n";
                print "expect it to be reported to the authorities in your country immediately.</li></ul>\n";
                if ($post_types > 0) {
                        print "<a name=\"3\"><h2>About your category</h2></a><ul>\n";
                        print "<li>I can easily move your category to another section if\n";
                        print "I feel that it doesn't belong where you put it.</li>\n";
                        print "<li>If I'm feeling vindictive, I can just delete your post\n";
                        print "if I feel you've placed it in the wrong category.</li></ul>\n";
                }
                print "<a name=\"4\"><h2>About your gallery's description</h2></a><ul>\n";
                print "<li>Please do not use all caps.  I can convert your gallery's\n";
                print "description to all lower case with the click of a button.</li>\n";
                print "<li>This is what people click on, so be as graphic as possible.</li>\n";
                print "Do not, however, lie.  If you do, I can change your gallery's description\n";
                print "to the filename of the gallery, which will probably get you a lot less hits.</li></ul>\n";
                print "<a name=\"7\"><h2>About your e-mail address</h2></a><ul>\n";
                print "<li>This is for internal use only, and will not be made\n";
                print "publically available.</li></ul>\n";
        }
        print "$postfoot$cfont</body></html>\n";
        exit;
}

sub preview {
        if ($samepage) { $FORM{'link_url'} = $FORM{'post_url'}; }
        &checkme;
        @stuff = ("post_type","post_url","post_desc","email","link_url","numimages");
        open(FILE,">$datadir/tempost.txt");
        foreach $thingie(@stuff) { print FILE "$FORM{$thingie}|"; }
        close(FILE);
        print "<html><head><title>Preview your post</title></head>\n";
        print "<frameset rows=\"50%,50%\">\n";
        print "<frame src=\"$scripturl?action=preview2\" name=\"top\">\n";
        print "<frame src=\"$FORM{'post_url'}\" name=\"bottom\">\n";
        print "</frameset><noframes>\n";
        &body("STDOUT");
        print "Please click these links to make sure that you gave the right URLs:<ul>\n";
        print "<li><a href=\"$FORM{'post_url'}\" target=\"post\">Post URL</a></li>\n";
        if ($FORM{'link_url'}) { print "<li><a href=\"$FORM{'link_url'}\" target=\"link\">Link URL</a></li>\n"; }
        print "</ul><form method=\"POST\" action=\"$scripturl\">\n";
        print "<input type=\"hidden\" name=\"action\" value=\"post\">\n";
        foreach $thingie(@stuff) { print "<input type=\"hidden\" name=\"$thingie\" value=\"$FORM{$thingie}\">\n"; }
        print "Once you're sure you gave the correct URLs, click <input type=\"submit\" value=\" this button \">.\n";
        print "</form></noframes></body></html>\n";
        exit;
}

sub preview2 {
        open(FILE,"$datadir/tempost.txt");
        $temp = <FILE>;
        close(FILE);
        ($FORM{'post_type'},$FORM{'post_url'},$FORM{'post_desc'},$FORM{'email'},$FORM{'link_url'},$FORM{'numimages'},$junk) = split(/\|/,$temp);
        &top("Preview your post","STDOUT");
        print "Please make sure that you gave the correct URLs.  Each link opens in the bottom window.<ul>\n";
        print "<li><a href=\"$FORM{'post_url'}\" target=\"bottom\">Post URL</a></li>\n";
        if ($FORM{'link_url'}) { print "<li><a href=\"$FORM{'link_url'}\" target=\"bottom\">Link URL</a></li>\n"; }
        print "</ul><form method=\"POST\" target=\"_top\" action=\"$scripturl\">\n";
        @stuff = ("post_type","post_url","post_desc","email","link_url","numimages");
        print "<input type=\"hidden\" name=\"action\" value=\"post\">\n";
        foreach $thingie(@stuff) { print "<input type=\"hidden\" name=\"$thingie\" value=\"$FORM{$thingie}\">\n"; }
        print "Once you're sure you gave the correct URLs, click <input type=\"submit\" value=\" this button \">.\n";
        print "</form></body></html>\n";
}

sub post {
        &checkme;
        open(FILE,"$datadir/auto.txt");
        @autos = <FILE>;
        close(FILE);
        foreach $auto(@autos) {
                chomp($auto);
                if ($FORM{'post_url'} =~ /$auto/) { $approval = 0; }
        }
        &gettime;
        if ($lwp && $checkapprove && $link) {
                $searchlink =~ s/\s+/ /g;
                $searchlink =~ tr/A-Z/a-z/;
                $searchlink = quotemeta($searchlink);
                if (length($tgptitle) > 36) { $temp = substr($tgptitle,0,36); }
                else { $temp = $tgptitle; }
                $searchlink2 = quotemeta("[<a href=\"$counturl?$mainurl\" target=\"new\"><font color=\"#FF0000\">$temp</font></a>]");
                $searchlink2 =~ s/\s+/ /g; $searchlink2 =~ tr/A-Z/a-z/;
                $page = get($FORM{'link_url'});
                $page =~ s/\s+/ /g;
                $page =~ tr/A-Z/a-z/;
                unless ($page =~ /$searchlink/ || $page =~ /$searchlink2/) { &error("Please add my link to your <a href=\"$FORM{'link_url'}\">links page</a>."); }
        }
        if ($approval) {
                unless ($FORM{'test'}) {
                        open(FILE,">>$datadir/approve.txt");
                        print FILE "$FORM{'post_type'}|$FORM{'post_url'}|$FORM{'post_desc'}|$FORM{'email'}|$FORM{'link_url'}|$date|$time|$FORM{'numimages'}|$ENV{'REMOTE_ADDR'}|\n";
                        close(FILE);
                }
                if ($notify1 && $youremail && $FORM{'test'} != -1) {
                        open (MAIL,"|$mailprogram -t");
                        print MAIL "To: $youremail\n";
                        print MAIL "From: $FORM{'email'}\n";
                        print MAIL "Subject: Thumbnail Gallery Post Needs Your Approval\n";
                        print MAIL "Hello.  On $date at $time $FORM{'email'}\n";
                        print MAIL "stopped by your TGP site and posted a gallery.\n";
                        print MAIL "Please stop by your page at $adminurl\n";
                        print MAIL "and approve it sometime.\n";
                        close (MAIL);
                }
                &top("Thank you!","STDOUT");
                print "Thank you for your post!  I will check it out and let you know as soon as possible.\n";
                if ($moreposts) { &moreposts; }
                print "</body></html>\n";
                exit;
        }
        else {
                unless ($FORM{'test'}) {
                        open(FILE,"$datadir/posts.txt");
                        @lines = <FILE>;
                        close(FILE);
                        if (@lines) { &getpost(0); }
                        else { $index_num = -1; }
                        $index_num++;        
                        splice(@lines,0,0,"$FORM{'post_type'}|$FORM{'post_url'}|$FORM{'post_desc'}|$FORM{'email'}|$FORM{'link_url'}|$date|$time|$FORM{'numimages'}|$ENV{'REMOTE_ADDR'}|$index_num\n");
                        open(FILE,">$datadir/c$index_num.txt");
                        print FILE "0";
                        close(FILE);
                        open(FILE,">$datadir/r$index_num.txt");
                        print FILE "5|1|";
                        close(FILE);                
                }
                &top("Gallery posted","STDOUT");
                print "The gallery has been posted and can be found at <a href=\"$posturl/$index_num$ex\">$posturl/$index_num$ex</a>.\n";
                if ($moreposts) { &moreposts; }
                unless ($FORM{'test'}) {
                        &checkpersite($FORM{'post_url'});
                        open(FILE,">$datadir/posts.txt");
                        foreach $line(@lines) { print FILE "$line"; }
                        close(FILE);
                        unless ($norate) { $FORM{'rr'} = -1; }
                        if ($link =~ /$counturl\?/) { $FORM{'rt'} = -1; }
                        unless ($lnumimages) { $FORM{'rn'} = -1; }
                        &update;
                }
                print "$cfont</body></html>\n";
                exit;                                         
        }
}

sub checkme {
        if ($#post_types > 0) {
                unless ($FORM{'post_type'}) { &error("Please select a category for your post."); }
                unless (@temp = grep(/$FORM{'post_type'}/,@post_types)) { &error("I don't have a $FORM{'post_type'} category."); }
        }
        unless ($FORM{'post_desc'}) { &missing("a description of the gallery"); }
        unless ($FORM{'post_url'} =~ /^http\:\/\/.+\.\w\w+.*/) { &error("The <a href=\"$FORM{'site_url'}\">site URL</a> appears to be invalid."); }
        unless ($FORM{'email'} =~ /.+\@.+\.\w\w+/) { &error("The e-mail address <a href=\"mailto:$FORM{'email'}\">$FORM{'email'}</a> appears to be invalid."); }
        if ($link && $FORM{'link_url'} !~ /^http\:\/\/.+\.\w\w+.*/) { &error("The <a href=\"$FORM{'link_url'}\">return link URL</a> appears to be invalid."); }
        open(FILE,"$datadir/lock.txt");
        my @locks = <FILE>;
        close(FILE);
        my $temp = "$FORM{'post_type'}|$FORM{'post_url'}|$FORM{'post_desc'}|$FORM{'email'}|$FORM{'link_url'}|$ENV{'REMOTE_ADDR'}";
        $temp =~ tr/A-Z/a-z/;
        foreach $lock(@locks) {
                chomp($lock);
                $templock = quotemeta($lock);
                $templock =~ tr/A-Z/a-z/;
                if ($temp =~ /$templock/) { &error("I have locked out the text <i>$lock</i>."); }
        }
        if ($samedomain && $link) {
                my @temp = split(/\//, $FORM{'post_url'});
                if ($FORM{'link_url'} !~ /$temp[2]/) { &error("Your gallery URL and return link URL must be on the same domain."); }
        }
        @ix = ("approve","posts");
        foreach $filename(@ix) {
                open(FILE,"$datadir/$filename.txt");
                my @lines = <FILE>;
                close(FILE);
                for ($i = 0; $i <= $#lines; $i++) {
                        ($post_type,$post_url,$post_desc,$email,$link_url,$odate,$otime,$numimages,$posters_ip,$index_num) = split(/\|/,$lines[$i]);
                        if ($post_url eq $FORM{'post_url'}) { &error("That gallery has already been posted."); }
                }
        }
}

sub moreposts {
        print "<p><center><table width=\"500\" border=\"5\" bgcolor=\"#FF0000\">\n";
        print "<tr><td><center>$font<font color=\"#000000\">The owner of this pic-post\n";
        print "page is using Cliff's ever-so-wonderful &quot;Get More Posts&quot;\n";
        print "system.  What does this mean to you?  Well, simply that you can easily\n";
        print "post the gallery that you just posted here to other pic-post sites without\n";
        print "having to fill out all the information again.  If you'd like to do this now,\n";
        print "please click<form method=\"POST\" action=\"http://www.shavenferret.com/cgi-bin/tpost.cgi\">\n";
        @checkthese = ("post_type","post_url","post_desc","email","link_url","numimages");
        foreach $check(@checkthese) { print "<input type=\"hidden\" name=\"$check\" value=\"$FORM{$check}\">\n"; }
        print "<input type=\"hidden\" name=\"from\" value=\"$posturl/\">\n";
        print "<input type=\"submit\" value=\" This Button \"></form></td></tr></table>\n";
}

sub search {
        unless ($FORM{'text'}) { &error("Please enter some terms you want to search for."); }
        $FORM{'text'} =~ tr/A-Z/a-z/;
        $FORM{'text'} =~ s/ not / -/ig;
        $FORM{'text'} =~ s/ and / \+/ig;
        $FORM{'text'} =~ s/ or / /ig;
        $FORM{'text'} =~ s/\s+/ /g;
        @temp = split(/\"/, $FORM{'text'});
        if ($keepsearch) {
                open(FILE,"$datadir/search.txt");
                my @searches = <FILE>;
                close(FILE);
                for($i = 0; $i <= $#searches; $i++) {
                        @stuff = split(/\|/, $searches[$i]);
                        if ($stuff[0] eq $FORM{'text'}) {
                                chomp($stuff[1]);
                                $stuff[1]++;
                                $searches[$i] = "$stuff[0]|$stuff[1]\n";
                                $found = -1;
                        }
                }
                unless ($found) { splice(@searches,0,0,"$FORM{'text'}|1\n"); }
                open(FILE,">$datadir/search.txt");
                foreach $search(@searches) { print FILE "$search"; }
                close(FILE);
        }
        for ($i = 0; $i <= $#temp; $i++) {
                $sign = "";
                if ($temp[$i]) {
                        if (substr($temp[$i],-1,1) eq "+" || substr($temp[$i],-1,1) eq "-") { $sign = substr($temp[$i],-1,1); chop($temp[$i]); }
                        @terms = split(/ /, $temp[$i]);        
                        foreach $term(@terms) {
                                $term =~ s/\s//ig;
                                if (substr($term,0,1) eq "+") {
                                        $term = substr($term,1,length($term)-1);
                                        push(@must,$term);
                                }
                                elsif (substr($term,0,1) eq "-") {
                                        $term = substr($term,1,length($term)-1);
                                        push(@cant,$term);
                                }
                                else { push(@should,$term); }
                        }
                }
                $i++;
                if ($temp[$i]) {
                        if ($sign eq "+") { push(@must,$temp[$i]); }
                        elsif ($sign eq "-") { push(@cant,$temp[$i]); }
                        else { push(@should,$temp[$i]); }
                }
        }
        open(FILE,"$datadir/posts.txt");
        @lines = <FILE>;
        close(FILE);
        if (@should) {
                for ($i = 0; $i <= $#lines; $i++) {
                        $lines[$i] =~ tr/A-Z/a-z/;
                        foreach $term(@should) {
                                if ($lines[$i] =~ /$term/) { push(@found,"$i"); last }
                        }
                }
        }
        else {  for ($i = 0; $i <= $#lines; $i++) { $lines[$i] =~ tr/A-Z/a-z/; $found[$i] = "$i"; } }
        if (@must) {
                for ($i = $#found; $i >= 0; $i--) {
                        foreach $term(@must) { unless ($lines[$found[$i]] =~ /$term/) { splice(@found,$i,1); last } }
                }
        }
        if (@cant) {
                for ($i = $#found; $i >= 0; $i--) {
                        foreach $term(@cant) { if ($lines[$found[$i]] =~ /$term/) { splice(@found,$i,1); last } }
                }
        }
        unless (@found) {
                &top("No results","STDOUT");
                print "I'm sorry, but your search turned up no results.  Please\n";
                print "click back and try again.$cfont</body></html>\n";
                exit;
        }
        if ($#post_types > 0) {               
                for ($i = 0; $i <= $#post_types; $i++) {
                        $temp = $post_types[$i];
                        $temp =~ tr/A-Z/a-z/;
                        $TYPE{$temp} = $i;
                }
        }
        &top("$tgptitle - Results - $FORM{'text'}","STDOUT","","",-1);
        print "<center>$head<br>";
        &banners("STDOUT");
        print "<h1><a href=\"$posturl/index$ex\">$tgptitle</a> - Results - <i>$FORM{'text'}</i></h1>\n";
        &jump("STDOUT");
        &sig("STDOUT");
        print "<center><table width=\"550\" border=\"5\"><tr><td>\n";
        unless ($#post_types <= 0) {
                print "<table cols=\"4\"><tr><td width=\"125\"><center>$font\n";
                print "category$cfont</center></td><td width=\"315\">\n";
        }
        else { print "<table cols=\"3\"><tr><td width=\"440\">\n"; }
        print "$font<center>Description</center>$cfont</td>\n";
        print "<td width=\"50\">$font<center>\n";
        unless ($norate) { print "Rating"; }
        else { print "Posted on.."; }
        print "</center>$cfont</td><td width=\"50\">$font<center>Images</center>$cfont</td></tr>\n";
        for ($postnum = 0; $postnum <= $#found; $postnum++) {
                &getpost($found[$postnum]);
                $temp = $post_type;
                $temp =~ tr/A-Z/a-z/;
                unless ($#post_types <= 0) { print "<tr><td width=\"125\">$font<center><a href=\"$posturl/i$TYPE{$temp}-0$ex\">$post_type</a></center>$cfont</td><td width=\"315\">\n"; }
                else { print "<tr><td width=\"440\">\n"; }
                print "$font<center><a href=\"$counturl?action=go&num=$index_num\">$post_desc</a></center>$cfont</td>\n";
                unless ($norate) {
                        open(FILE,"$datadir/r$index_num.txt");
                        my $stuff = <FILE>;
                        close(FILE);
                        ($total,$votes,$junk) = split(/\|/,$stuff);
                        if ($votes) { $rating = sprintf("%.2f", $total / $votes); }
                        else { $rating = "5"; }
                        print "<td width=\"50\">$font<center>$rating</center>$cfont</td>\n";
                }
                else { print "<td width=\"50\">$font<center>$odate</center>$cfont</td>\n"; }
                print "<td width=\"50\">$font<center>$numimages</center>$cfont</td></tr>\n";
        }
        print "</table></td></tr></table>\n";
        &searchwindow("STDOUT");
        &sig("STDOUT");
        &banners("STDOUT");
        print "<br>$foot$cfont</body></html>";
        exit;
}

sub random {
        open(FILE,"$datadir/posts.txt");
        @lines = <FILE>;
        close(FILE);
        srand;
        $i = int(rand($#lines));
        &getpost($i);
        print "Location: $posturl/$index_num$ex\n\n";
}
